! Solve the N-Queens puzzle.
! Nils M Holm, 2004
! See the file LICENSE for conditions of use.

! Usage: queens size

module queens(t3x, string, util);

object	t[t3x], str[string], u[util];

abs(x) return x<0-> -x: x;

print(board, size) do var i;
	for (i=0, size)
		u.printf(" %d", [(board[i])]);
	u.printf("\n", 0);
end

safe(pos, board, size, n) do var i, bpos;
	for (i=0, n) do
		bpos := board[i];
		if (bpos / size = pos / size) return 0;
		if (bpos mod size = pos mod size) return 0;
		if (abs(bpos mod size - pos mod size)
			= abs(bpos / size - pos / size)
		)
			return 0;
	end
	return 1;
end

solve(board, size) do var here, row, col;
	row := 0;
	col := 0;
	here := 0;
	while (1) do
		ie (row >= size) do
			if (col >= size) print(board, size);
			col := col - 1;
			if (col < 0) leave;
			here := board[col] + 1;
			row := (here-1) mod size + 1;
		end
		else ie (safe(here, board, size, col)) do
			board[col] := here;
			col := col+1;
			here := col*size;
			row := 0;
		end
		else do
			here := here + 1;
			row := row + 1;
		end
	end
end

do var board[100], buf::4;
	if (t.getarg(1, buf, 4) < 1) halt 1;
	solve(board, str.strtonum(buf, 10, 0));
end
