@echo off

REM Installation Batch File for DOS
REM Nils M Holm, 2003, 2019
REM See the file LICENSE for conditions of use.

if x%1 == x goto end

set T3XDIR=%1

mkdir %1
mkdir %1\bin
mkdir %1\classes
mkdir %1\lib
mkdir %1\doc
mkdir %1\tide

echo char:t3x>..\classes\char.ndx
echo iostream:t3x>..\classes\iostream.ndx
echo memory:t3x>..\classes\memory.ndx
echo string:t3x>..\classes\string.ndx
echo util:t3x,string,iostream>..\classes\util.ndx
echo system:t3x>..\classes\system.ndx
echo ttyctl:t3x>..\classes\ttyctl.ndx
echo xmem:t3x>..\classes\xmem.ndx
echo remove-me:>%1\classes\CLASSNDX

copy ..\Boot\txx.exe %1\bin\txx.exe

copy ..\compiler\txdpf.exe %1\bin
copy ..\compiler\txld.exe %1\bin
copy ..\compiler\txopt.exe %1\bin
copy ..\compiler\txtrn.exe %1\bin

copy ..\compiler\tcode.dir %1\classes
copy ..\classes\tcode.cls %1\classes
..\tools\txcm -qi t3x
cd ..\classes
..\tools\txcm -i char
..\tools\txcm -i iostream
..\tools\txcm -i memory
..\tools\txcm -i string
..\tools\txcm -i util
..\tools\txcm -i system
..\tools\txcm -i ttyctl
..\tools\txcm -i xmem

cd ..\native
copy txcgexe.exe %1\bin\txcgexe.exe
copy txcgexe.exe %1\bin\txcg86.exe
copy txcgexe.exe %1\bin\txcgl.exe
copy ts86.exe %1\bin\ts86.exe
copy t3x.x %1\lib

cd ..\tools
copy tx.exe %1\bin\tx.exe
copy txcm.exe %1\bin\txcm.exe
copy txdump.exe %1\bin\txdump.exe
copy txprint.exe %1\bin\txprint.exe
copy txsdfmt.exe %1\bin\txsdfmt.exe
copy txsum.exe %1\bin\txsum.exe
copy txprint.rules %1\txprint.rul
copy txmake.exe %1\bin\txmake.exe
copy txhelp.exe %1\bin\txhelp.exe

if not exist ..\tide\tide.exe goto notide
cd ..\tide
..\tools\txcm -i config
..\tools\txcm -i editor
..\tools\txcm -i filebox
..\tools\txcm -i filesrv
..\tools\txcm -i form
..\tools\txcm -i menu
..\tools\txcm -i prompt
..\tools\txcm -i pstruct
..\tools\txcm -i vedit
..\tools\txcm -i xeditor
..\tools\txcm -i xvedit
copy tide.exe %1\bin\tide.exe
copy tideconf.exe %1\bin\tideconf.exe
copy helpfile %1\tide\helpfile
copy ..\ports\dos-exe\tide.rc %1\tide.rc
copy ..\ports\dos-exe\*.cs %1\tide
:notide

cd ..
copy docs\*.sd %1\doc
copy docs\t3x-book.txt %1\doc
copy docs\sdtoc %1\doc
copy LICENSE %1\doc

copy ports\dos-exe\txrc %1\system.txr

cd compiler

echo.
echo Don't forget to define T3XDIR = %1
echo.

:end
